#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_JuKunPaiHangCFG.h"
std::auto_ptr<Fish_JuKunPaiHangCFG> Fish_JuKunPaiHangCFG::msSingleton(nullptr);

int Fish_JuKunPaiHangCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JuKunPaiHangCFGData* Fish_JuKunPaiHangCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_JuKunPaiHangCFGData>& Fish_JuKunPaiHangCFG::GetMapData()
{
	return mMapData;
}

void Fish_JuKunPaiHangCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_JuKunPaiHangCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JuKunPaiHangCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mTime = element->IntAttribute("Time");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* Reward = element->Attribute("Reward");
			std::vector<std::string> vecReward;
			boost::split(vecReward, Reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecReward[i].c_str(), &temp))
				{
					data.mReward.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_JuKunPaiHangCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunPaiHangCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_JuKunPaiHangCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_JuKunPaiHangCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_JuKunPaiHangCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Time", data.mTime);
		LuaCfgHelper::readInt(L, "StartRank", data.mStartRank);
		LuaCfgHelper::readInt(L, "EndRank", data.mEndRank);
		LuaCfgHelper::readVectorInt(L, "Reward", data.mReward);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_JuKunPaiHangCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunPaiHangCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_JuKunPaiHangCFG* Fish_JuKunPaiHangCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JuKunPaiHangCFG());
	}
	return msSingleton.get();
}

void Fish_JuKunPaiHangCFG::Release()
{
	msSingleton.reset(nullptr);
}
